//
//  InternalContactDataModel.h
//  GCall
//
//  Created by HL on 2018/3/17.
//  Copyright © 2018年 gcall. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface JavaModel : NSObject
@property (nonatomic, assign) long long id_;
@property (nonatomic, strong) NSString *name;
@property (nonatomic, strong) NSString *icon;
@end

/** 后台返回数据模型 -- 由于是界面展示：故本地自定义*/
@interface JavaListModel : NSObject
/** 当前树状图的第一层级数组 */
@property (nonatomic, strong) NSArray<JavaModel *> *firstArray;
/** 所有树状图的子集 集合 model的id_为Key value为id_的子集 集合*/
@property (nonatomic, strong) NSDictionary<NSString *, NSArray<JavaModel *>*> *mapDate;
@end

@interface InternalContactDataModel : NSObject
@property (nonatomic, assign) long long id_;
@property (nonatomic, strong) NSString *name;
@property (nonatomic, strong) NSString *icon;

/** 当前主页所处的树状图的层级 */
@property (nonatomic, assign) int modelLayer;
/** 当前主页节点  是否收起 */
@property (nonatomic, assign) BOOL isFold;
/** 当前主页节点  是否为当前子集的最后一个节点 */
@property (nonatomic, assign) BOOL isLastModel;
/** 当前树状图cell，左侧需要展示的线的数组 */
@property (nonatomic, strong) NSMutableArray *showIndexArray;
/** 当前节点的所有子节点 */
@property (nonatomic, strong) NSMutableArray *childrenArray;

@property (nonatomic, strong) id innerContact;
+ (InternalContactDataModel *)setInternalContactDataModel:(JavaModel *)innerContact;

/** 当前树状图的第一层级数组*/
+ (NSMutableArray<InternalContactDataModel *> *)refreshMyPageInnerContactsAggregate:(JavaListModel *)aggregate;

/** 通过树状图的第一层级数组 根据里面的isFold参数 判断展开的节点 获取所有需要显示的节点*/
+ (NSMutableArray<InternalContactDataModel *> *)refreshShowArrayWithFirstListInnerArray:(NSMutableArray *)_firstListInnerArray;


@end
