//
//  InternalContactDataModel.m
//  GCall
//
//  Created by HL on 2018/3/17.
//  Copyright © 2018年 gcall. All rights reserved.
//

#import "InternalContactDataModel.h"

@implementation JavaListModel
@end

@implementation JavaModel
@end

@implementation InternalContactDataModel

+ (InternalContactDataModel *)setInternalContactDataModel:(JavaModel *)innerContact
{
    InternalContactDataModel *model = [InternalContactDataModel new];
    model.id_ = innerContact.id_;
    model.name = innerContact.name;
    model.icon = innerContact.icon;

    model.innerContact = innerContact;
    model.isFold = NO;
    model.isLastModel = NO;
    model.showIndexArray = [NSMutableArray new];
    model.childrenArray = [NSMutableArray new];
    return model;
}


+ (NSMutableArray *)refreshMyPageInnerContactsAggregate:(JavaListModel *)aggregate {
    NSMutableArray *_firstListInnerArray = [[NSMutableArray alloc] init];
    for (JavaModel *contact in aggregate.firstArray) {
        InternalContactDataModel *model = [InternalContactDataModel setInternalContactDataModel:contact];
        model.modelLayer = 0;
        //判断是否为集合的最后一个model 参数用于判断是否需要展示bottomLine
        if (contact ==  [aggregate.firstArray lastObject]) {
            model.isLastModel = YES;
        }
        [self getMyChilrenPageInnerContacts:(InternalContactDataModel *)model chilrenMap:aggregate.mapDate];
        [_firstListInnerArray addObject:model];
    }
    return _firstListInnerArray;
}

+ (void)getMyChilrenPageInnerContacts:(InternalContactDataModel *)currentModel chilrenMap:(NSDictionary *)dic
{
    NSMutableArray *marr = [[NSMutableArray alloc] init];
    NSArray *chilren = [dic objectForKey:[NSNumber numberWithLong:currentModel.id_]];
    if (chilren.count) {
        for (JavaModel *contact in chilren) {
            InternalContactDataModel *model = [InternalContactDataModel setInternalContactDataModel:contact];
            model.modelLayer = currentModel.modelLayer + 1;
            if (contact ==  [chilren lastObject]) {
                model.isLastModel = YES;
            }
            /**
             showIndexArray判断节点之前的层级线是否需要完全展示
             子节点完全继承父节点的所有层级线
             再根据父节点是否为isLastModel，来判断是否需要加上父节点的层级线
             */
            NSMutableArray *showIndexArray = [[NSMutableArray alloc] initWithArray:currentModel.showIndexArray];
            if(!currentModel.isLastModel && model.modelLayer != 0) {
                [showIndexArray addObject:[NSString stringWithFormat:@"%d",(model.modelLayer - 1)]];
            }
            model.showIndexArray = showIndexArray;
            
            [self getMyChilrenPageInnerContacts:model chilrenMap:dic];
            [marr addObject:model];
        }
    }
    currentModel.childrenArray = marr;
}



+ (NSMutableArray *)refreshShowArrayWithFirstListInnerArray:(NSMutableArray *)_firstListInnerArray
{
    NSMutableArray *_showInnerModelArray = [[NSMutableArray alloc] init];
    for (InternalContactDataModel *model in _firstListInnerArray) {
        [_showInnerModelArray addObject:model];
        [self refreshShowArray:_showInnerModelArray getChilrenModel:model];
    }
    return _showInnerModelArray;
}

+ (void)refreshShowArray:(NSMutableArray *)_showInnerModelArray getChilrenModel:(InternalContactDataModel *)currentModel
{
    if(!currentModel.isFold && currentModel.childrenArray.count)
    {
        for (InternalContactDataModel *model in currentModel.childrenArray) {
            [_showInnerModelArray addObject:model];
            [self refreshShowArray:_showInnerModelArray getChilrenModel:model];
        }
    }
}


@end
