//
//  InternalContactTableViewCell.m
//  GCall
//
//  Created by HL on 2018/3/17.
//  Copyright © 2018年 gcall. All rights reserved.
//

#import "InternalContactTableViewCell.h"

@implementation InternalContactTableViewCell
{
    UIButton *_clickBtn;
    
    VerticalLineView *_line2;
    VerticalLineView *_line3;
    VerticalLineView *_line4;
    VerticalLineView *_line5;
    VerticalLineView *_line6;
    
    UIView *_horizontalLine;
    
    NSArray *_lineArray;
    
}
- (void)awakeFromNib {
    [super awakeFromNib];
    // Initialization code
}

- (instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier
{
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if (self) {
        [self initUI];
        _lineArray = [[NSArray alloc] initWithObjects:_line1,_line2,_line3,_line4,_line5,_line6,nil];
    }
    return self;
}

- (void)btnClick {
    if ([_delegate respondsToSelector:@selector(foldMyContactListWith:)]) {
        [_delegate foldMyContactListWith:_model];
    }
}

- (void)initUI
{
    _line1 = [[VerticalLineView alloc] init];
    _line2 = [[VerticalLineView alloc] init];
    _line3 = [[VerticalLineView alloc] init];
    _line4 = [[VerticalLineView alloc] init];
    _line5 = [[VerticalLineView alloc] init];
    _line6 = [[VerticalLineView alloc] init];
    _line2.hidden = YES;
    _line3.hidden = YES;
    _line4.hidden = YES;
    _line5.hidden = YES;
    _line6.hidden = YES;

    _clickBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    [_clickBtn addTarget:self action:@selector(btnClick) forControlEvents:UIControlEventTouchUpInside];
    _clickBtn.backgroundColor = [UIColor clearColor];
    
    _horizontalLine = [[UIView alloc] init];
    _horizontalLine.backgroundColor = [UIColor redColor];
    
    _icon_ImageView = [[UIImageView alloc] init];
    _title_Label = [[UILabel alloc] init];
    _title_Label.font =  [UIFont systemFontOfSize:16];
    _title_Label.textColor  = [UIColor redColor];
    
    [self.contentView addSubview:_line1];
    [self.contentView addSubview:_line2];
    [self.contentView addSubview:_line3];
    [self.contentView addSubview:_line4];
    [self.contentView addSubview:_line5];
    [self.contentView addSubview:_line6];

    [self.contentView addSubview:_horizontalLine];
    
    [self.contentView addSubview:_clickBtn];
    [self.contentView addSubview:_icon_ImageView];
    [self.contentView addSubview:_title_Label];
    
    [_line1 setFrame:CGRectMake(10, 0, 7, InternalContactTableViewCellHeight+1)];
    [_line2 setFrame:CGRectMake(17, 0, 7, InternalContactTableViewCellHeight+1)];
    [_line3 setFrame:CGRectMake(24, 0, 7, InternalContactTableViewCellHeight+1)];
    [_line4 setFrame:CGRectMake(31, 0, 7, InternalContactTableViewCellHeight+1)];
    [_line5 setFrame:CGRectMake(38, 0, 7, InternalContactTableViewCellHeight+1)];
    [_line6 setFrame:CGRectMake(45, 0, 7, InternalContactTableViewCellHeight+1)];

    CGFloat Y = (InternalContactTableViewCellHeight - 36) / 2;
    [_icon_ImageView setFrame:CGRectMake(80, Y, 36, 36)];
    [_title_Label setFrame:CGRectMake(_icon_ImageView.frame.origin.x + _icon_ImageView.frame.size.width + 10, Y, 150, _title_Label.font.lineHeight)];
    
    [_clickBtn setFrame:CGRectMake(0, 0, 80, InternalContactTableViewCellHeight)];
    
    CGFloat X = _line1.frame.size.width + _line1.frame.origin.x;
    [_horizontalLine setFrame:CGRectMake(X, 13, 70 - X, 1)];
}

-(void)setModel:(InternalContactDataModel *)model
{
    _model = model;
    _icon_ImageView.image = [UIImage imageNamed:@""];
    _title_Label.text = model.name;
    [self resetLineView];
}

- (void)resetLineView
{
    for (VerticalLineView *line in _lineArray) {
        [line resetView];
        line.hidden = YES;
    }
    
    if (_model.showIndexArray.count) {
        for (NSString *numIndex in _model.showIndexArray) {
            int index = [numIndex intValue];
            if (index < _lineArray.count) {
                VerticalLineView *line = [_lineArray objectAtIndex:index];
                line.hidden = NO;
            }
        }
    }

    if (_model.modelLayer <= _lineArray.count) {
        VerticalLineView *line = [_lineArray objectAtIndex:_model.modelLayer];
        line.hidden = NO;
        line.nodeBtn.hidden = NO;
        if (_model.isLastModel) {
            line.isShowBottomLine = NO;
        }
        if (_model.childrenArray.count) {
            line.nodeBtn.selected = !_model.isFold;
            if (!_model.isFold && (_model.modelLayer + 1) <= _lineArray.count) {
                VerticalLineView *lineA = [_lineArray objectAtIndex:(_model.modelLayer + 1)];
                lineA.hidden = NO;
                lineA.isShowTopLine = NO;
            }
        } else {
            line.nodeBtn.enabled = NO;
        }
        
        CGFloat X = line.frame.size.width + line.frame.origin.x;
        [_horizontalLine setFrame:CGRectMake(X, 13, 70 - X, 1)];
    }
}


- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}

@end
