//
//  VerticalLineView.m
//  GCall
//
//  Created by HL on 2018/3/17.
//  Copyright © 2018年 gcall. All rights reserved.
//

#import "VerticalLineView.h"

@implementation VerticalLineView
{
    UIView *_topLine;
    UIView *_bottomLine;
}

- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        [self setBackgroundColor:[UIColor clearColor]];
        [self initUI];
        [self resetView];
    }
    return self;
}

- (void)initUI
{
    _topLine = [[UIView alloc] init];
    _topLine.backgroundColor = [UIColor redColor];
    _bottomLine = [[UIView alloc] init];
    _bottomLine.backgroundColor = [UIColor redColor];

    _nodeBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    [_nodeBtn setImage:[UIImage imageNamed:@"ltd_IM_btn_3_1"] forState:UIControlStateNormal];
    [_nodeBtn setImage:[UIImage imageNamed:@"ltd_IM_btn_3_2"] forState:UIControlStateSelected];
    [_nodeBtn setImage:[UIImage imageNamed:@"ltd_IM_btn_3_3"] forState:UIControlStateDisabled];

    [self addSubview:_topLine];
    [self addSubview:_bottomLine];
    [self addSubview:_nodeBtn];
}

- (void)layoutSubviews
{
    [super layoutSubviews];
    [self refreshUIFrame];
}

- (void)refreshUIFrame
{
    CGFloat lineW = 1;
    CGFloat X = (self.frame.size.width - lineW) / 2;
    [_topLine setFrame:CGRectMake(X, 0, lineW, 13)];
    
    CGFloat nWidth = 7;
    CGFloat nX = (self.frame.size.width - nWidth) / 2;
    CGFloat nY = _topLine.frame.size.height + _topLine.frame.origin.y - nWidth / 2;
    [_nodeBtn setFrame:CGRectMake(nX, nY, nWidth, nWidth)];
    
    CGFloat bY = _topLine.frame.size.height + _topLine.frame.origin.y;
    CGFloat bHeight = self.frame.size.height - bY;
    [_bottomLine setFrame:CGRectMake(X, bY, lineW, bHeight)];
}

-(void)setIsShowTopLine:(BOOL)isShowTopLine
{
    _topLine.hidden = !isShowTopLine;
}

-(void)setIsShowBottomLine:(BOOL)isShowBottomLine
{
    _bottomLine.hidden = !isShowBottomLine;
}

-(void)resetView
{
    _topLine.hidden = NO;
    _bottomLine.hidden = NO;
    _nodeBtn.hidden = YES;
    _nodeBtn.selected = NO;
    _nodeBtn.enabled = YES;
}

@end
