//
//  ViewController.m
//  TreeStructure
//
//  Created by HL on 2018/3/20.
//  Copyright © 2018年 HL. All rights reserved.
//

#import "ViewController.h"
#import "InternalContactTableViewCell.h"
#import "InternalContactDataModel.h"

static NSString *InternalContactTableViewCellIdentifier = @"InternalContactTableViewCellIdentifier";
@interface ViewController ()<UITableViewDelegate, UITableViewDataSource, InternalContactTableViewCellDelegate>

@end

@implementation ViewController
{
    UITableView *_tableView;
    NSMutableArray *_showInnerModelArray;
    NSMutableArray *_firstListInnerArray;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    
    _tableView = [[UITableView alloc] initWithFrame:self.view.bounds style:(UITableViewStyleGrouped)];
    _tableView.delegate = self;
    _tableView.dataSource = self;
    _tableView.translatesAutoresizingMaskIntoConstraints = NO;
    _tableView.sectionIndexBackgroundColor = [UIColor clearColor];
    _tableView.sectionIndexColor = [UIColor grayColor];
    [self.view addSubview:_tableView];
    
    [self getInternalContactDate];
}

- (void)getInternalContactDate
{
    
    JavaModel *model1 = [self getModelWithName:@"1A" id:11111];
    JavaModel *model2 = [self getModelWithName:@"1B" id:11112];
    JavaModel *model3 = [self getModelWithName:@"1C" id:11113];
    
    JavaModel *model21 = [self getModelWithName:@"2A" id:11121];
    JavaModel *model22 = [self getModelWithName:@"2B" id:11122];
    JavaModel *model23 = [self getModelWithName:@"2C" id:11123];
    JavaModel *model24 = [self getModelWithName:@"2D" id:11124];
    JavaModel *model25 = [self getModelWithName:@"2E" id:11125];
    JavaModel *model26 = [self getModelWithName:@"2F" id:11126];

    JavaModel *model31 = [self getModelWithName:@"3A" id:11131];
    JavaModel *model32 = [self getModelWithName:@"3B" id:11132];
    JavaModel *model33 = [self getModelWithName:@"3C" id:11133];
    JavaModel *model34 = [self getModelWithName:@"3D" id:11134];
    JavaModel *model35 = [self getModelWithName:@"3E" id:11135];

    JavaModel *model41 = [self getModelWithName:@"4A" id:11141];
    JavaModel *model42 = [self getModelWithName:@"4B" id:11142];
    JavaModel *model43 = [self getModelWithName:@"4C" id:11143];

    JavaModel *model51 = [self getModelWithName:@"5A" id:11151];
    JavaModel *model52 = [self getModelWithName:@"5B" id:11152];
    JavaModel *model53 = [self getModelWithName:@"5C" id:11153];

    JavaModel *model61 = [self getModelWithName:@"6A" id:11151];
    /**本地数据生成java数据*/
    JavaListModel *javaModel = [[JavaListModel alloc] init];
    javaModel.firstArray = @[model1,model2,model3];
    javaModel.mapDate = @{
                          @(11111):@[model21,model22,model23],
                          @(11113):@[model24,model25,model26],
                          @(11121):@[model31],
                          @(11123):@[model32,model33],
                          @(11125):@[model34],
                          @(11126):@[model35],
                          @(11132):@[model41,model42,model43],
                          @(11141):@[model51],
                          @(11143):@[model52,model53],
                          @(11153):@[model61],
                        };
    _firstListInnerArray = [InternalContactDataModel refreshMyPageInnerContactsAggregate:javaModel];
    _showInnerModelArray = [InternalContactDataModel refreshShowArrayWithFirstListInnerArray:_firstListInnerArray];
    [_tableView reloadData];
}

- (JavaModel *)getModelWithName:(NSString *)name id:(long long)id_
{
    JavaModel *model = [[JavaModel alloc] init];
    model.name = name;
    model.id_ = id_;
    model.icon = @"";
    return model;
}

#pragma mark - InternalContactTableViewCellDelegate 自定义代理
- (void)foldMyContactListWith:(InternalContactDataModel *)model
{
    if (model) {
        model.isFold = !model.isFold;
        _showInnerModelArray = [InternalContactDataModel refreshShowArrayWithFirstListInnerArray:_firstListInnerArray];
    }
    [_tableView reloadData];
}


#pragma mark - tableView delegate & data source

-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return 1;
}

-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return _showInnerModelArray.count;
}

-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    InternalContactTableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:InternalContactTableViewCellIdentifier];
    if (!cell) {
        cell = [[InternalContactTableViewCell alloc] initWithStyle:(UITableViewCellStyleDefault) reuseIdentifier:InternalContactTableViewCellIdentifier];
    }
    InternalContactDataModel *model = _showInnerModelArray[indexPath.row];
    cell.model = model;
    if (indexPath.row == 0) {
        //列表的第一位 要隐藏topLine
        cell.line1.isShowTopLine = NO;
    }
    cell.delegate = self;
    cell.selectionStyle = UITableViewCellSelectionStyleNone;
    return cell;

}

-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    return InternalContactTableViewCellHeight;
}

-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
}

-(void)tableView:(UITableView *)tableView willDisplayCell:(UITableViewCell *)cell forRowAtIndexPath:(NSIndexPath *)indexPat{
    //设置cell横线满格
    if ([cell respondsToSelector:@selector(setLayoutMargins:)]) {
        [cell setLayoutMargins:UIEdgeInsetsMake(0, 1000, 0, 0)];
    }
    if ([cell respondsToSelector:@selector(setSeparatorInset:)]){
        [cell setSeparatorInset:UIEdgeInsetsMake(0, 1000, 0, 0)];
    }
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


@end
